from xpcom import components, ServerException

from koLanguageServiceBase import *

class koErrorLanguage(KoLanguageBase):
    name = "Errors"
    _reg_desc_ = "%s Language" % name
    _reg_contractid_ = "@activestate.com/koLanguage?language=%s;1" \
                       % (name)
    _reg_clsid_ = "{A0E26D4B-42E2-408F-BEE4-DF3232A08636}"

    defaultExtension = ".err"
    styleBits = 5

    def get_lexer(self):
        if self._lexer is None:
            self._lexer = KoLexerLanguageService()
            self._lexer.setLexer(components.interfaces.ISciMoz.SCLEX_ERRORLIST)
            self._lexer.supportsFolding = 0
        return self._lexer

