<?

// meta, for userland validator readout
$server->add_to_map("whichToolkit",array(),array("struct"));
function whichToolkit(){
	return array(
		"toolkitDocsUrl"=>"http://dietrich.ganx4.com/soapx4",
		"toolkitName"=>"SOAPx4",
		"toolkitVersion"=>"0.5",
		"toolkitOperatingSystem"=>"PHP / Linux"
	);
}

$server->add_to_map("countTheEntities",array("string"),array("struct"));
function countTheEntities($s){
	$arr = count_chars($s,1);
	$ret = array(
		"ctLeftAngleBrackets" => 0,
		"ctRightAngleBrackets" => 0,
		"ctAmpersands" => 0,
		"ctApostrophes" => 0,
		"ctQuotes" => 0);
	foreach($arr as $k => $v){
		//print chr($k)." : $v<br>";
		switch(chr($k)){
			case "<":
				$ret["ctLeftAngleBrackets"] = $v;
				break;
			case ">":
				$ret["ctRightAngleBrackets"] = $v;
				break;
			case "&":
				$ret["ctAmpersands"] = $v;
				break;
			case "'":
				$ret["ctApostrophes"] = $v;
				break;
			case '"':
				$ret["ctQuotes"] = $v;
				break;
		}
	}
	return $ret;
}

$server->add_to_map("easyStructTest",array("SOAPStruct"),array("int"));
function easyStructTest($stooges){
	foreach($stooges as $v){
		$sum += $v;
	}
	return $sum;
}

$server->add_to_map("echoStructTest",array("SOAPStruct"), array("SOAPStruct"));
function echoStructTest($struct){
	return $struct;
}

$server->add_to_map("manyTypesTest",array("int","boolean","string","float","timeInstant","string"),array("array"));
function manyTypesTest($num,$bool,$state,$doub,$dat,$bin){
	return array($num,"boolean"=>$bool,$state,"float"=>$doub,"timeInstant"=>$dat,$bin);
}

//echo "moderatesizearraycheck test: ".moderatesizearraycheck(array("to be ","kitty","or not to be"));
$server->add_to_map("moderateSizeArrayCheck",array("array"),array("string"));
function moderateSizeArrayCheck($arr){
	$a = array_shift($arr);
	$b = array_pop($arr);
	return $a.$b;
}

$server->add_to_map("nestedStructTest",array("SOAPStruct"),array("int"));
function nestedStructTest($struct){
	foreach($struct as $k => $v){
		if($k == "year2000"){
			foreach($v as $a => $b){
				if($a == "month04"){
					foreach($b as $c => $d){
						if($c == "day01"){
							foreach($d as $e){
								$f += $e;
							}
							return $f;
						}
					}
				}
			}
		}
	}
}

$server->add_to_map("simpleStructReturnTest",array("int"),array("SOAPStruct"));
function simpleStructReturnTest($num){
	return array("times10"=>$num*10,"times100"=>$num*100,"times1000"=>$num*1000);
}
?>