/* Copyright (c) 2000-2003 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */
   
/* misc. functions to deal with css styles */

function style_add(cell, aName, aValue) {
  var nullvalue = typeof(aValue)=='undefined' || !aValue;      
  var oldStyle;
  var newStyle = null;
  try {
    oldStyle = cell.getAttribute('style');
  } catch(e) {
    oldStyle = "";
  }
  if (oldStyle) {
    var foundIt = false;
    var a = oldStyle.split(";");
    var s;
    for (i in a) {
        s = a[i].split(':');
        if (aName == s[0]) {
            if (nullvalue) {
                // no value, remove the style
                a.splice(i,1);
            } else {
                a[i] = aName + ":" + aValue;
            }
            foundIt = true;
        }    
    }
    
    if (!foundIt && !nullvalue)
      a[a.length] = aName + ":" + aValue;
    newStyle = a.join(";");
  } else if (!nullvalue) {
    newStyle = aName + ":" + aValue;
  }
  if (newStyle) {
    cell.setAttribute('style', newStyle);
  }
}
