/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* Web Services Setup Wizard - panel 2 */

//---- globals

var _gPanelName = "finish";



//---- interface for pane_2.xul


function OnLoad()
{
    // Give a nice header name for this pane.
    var headerWidget = parent.document.getElementById("header");
    headerWidget.setAttribute("title", "Finished with installation");
    headerWidget.setAttribute("description",
        "The Setup Wizard has finished installing PHP Debugger support.");

    var donemsg = document.getElementById("finish-msg");
    var text;
    if (parent.wd_info.ok) {
        text = "PHP Debugging has been successfully configured."
    } else {
        text = "Sorry, PHP Debugging configuration failed. "+parent.wd_info.msg+
            "  Please consult the help file for more information on configuring "+
            "PHP.  If you still have problems, contact technical support at "+
            "support@ActiveState.com.";
    }
    donemsg.appendChild(document.createTextNode(text));

    // Disable the cancel button (XXX at least until this process
    // is made cancellable).
    var cancelButton = parent.document.getElementById("wiz-cancel-button");
    cancelButton.disabled = true;
    
    parent.wizardManager.onPageLoad(_gPanelName);
}


function OnUnload()
{
}