/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* Web Services Setup Wizard - panel 2 */

//---- globals

var _gPanelName = "install";



//---- interface for pane_2.xul


function OnLoad()
{
    // Give a nice header name for this pane.
    var headerWidget = parent.document.getElementById("header");
    headerWidget.setAttribute("title", "Ready To Install");
    headerWidget.setAttribute("description",
        "The Setup Wizard is ready to configure PHP Debugger support.");

    // Change the "Next" button to say "Install".
    var nextButton = parent.document.getElementById("wiz-next-button");
    nextButton.setAttribute("label", "Install");

    // Describe the installation procedure.
    var actionWidget = document.getElementById("php-executable");
    var description = 'PHP Executable: '+parent.wd_info.interpreter;
    var textNode = document.createTextNode(description);
    actionWidget.appendChild(textNode);

    actionWidget = document.getElementById("php-inipath");
    description = 'PHP INI Path: '+parent.wd_info.ini;
    textNode = document.createTextNode(description);
    actionWidget.appendChild(textNode);

    actionWidget = document.getElementById("php-extensions");
    description = 'PHP Extension Directory: '+parent.wd_info.extensionDir;
    textNode = document.createTextNode(description);
    actionWidget.appendChild(textNode);

    parent.wizardManager.onPageLoad(_gPanelName);
}


function OnUnload()
{
    // Restore "Next" to the Next button.
    var nextButton = parent.document.getElementById("wiz-next-button");
    nextButton.setAttribute("label", "Next");
}