/* Copyright (c) 2000-2003 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */


/*
 * checkComspec
 *
 * checks os and compspec to see if comspec is incorrect
 * allways returns true on non-windows platforms
 *
 * returns boolean
 */
function checkComspec()
{








    return true;
}

var wizardManager = null;
var wd_info = null;
var _gOs = Components.classes["@activestate.com/koOs;1"].createInstance();
var _gPhpInfo = Components.classes["@activestate.com/koPHPInfoInstance;1"].createInstance();
var _gOsPath = Components.classes["@activestate.com/koOsPath;1"].getService();
var _gInfoSvc = Components.classes["@activestate.com/koInfoService;1"].getService();

var wizardMap = {
    start: {
        previous: null,
        next: "chooseInstallation",
        finish: false },
    chooseInstallation: {
        previous: "start",
        next: "chooseIni",
        finish: false },
    chooseIni: {
        previous: "chooseInstallation",
        next: "chooseExtensionDir",
        finish: false },
    chooseExtensionDir: {
        previous: "chooseIni",
        next: "install",
        finish: false },
    install: {
        previous: "chooseExtensionDir",
        next: "installing",
        finish: false },
    installing: {
        previous: null,
        next: null,
        finish: false },
    finish: {
        previous: null,
        next: null,
        finish: true }
}

//---- interface routines for wsSetupWizard.xul

function OnLoad(contentFrameId)
{
    // instantiate the Wizard Manager
    wizardManager = new WizardManager(contentFrameId, null, null,
                                      wizardMap);
    wizardManager.URL_PagePrefix = "chrome://jaguar/content/wizards/setup/php/";
    wizardManager.URL_PagePostfix = ".xul";

    // set the button handler functions
    wizardManager.SetHandlers(null,         // onNext
                              null,         // onBack
                              onFinish,       // onFinish
                              onCancel, // onCancel
                              null,     // onPageLoad
                              null);    // wizard button enablingFunc

    // set wizard data for the panels
    wd_info = window.arguments[0];
    
    // load the start panel
    // - explicit launch of wizard: Intro panel
    // - implicit launch of wizard: WantToSetup panel
    var startPanel = "start";
    wizardManager.LoadPage(startPanel, false);

    moveToAlertPosition();
}

function onInit()
{
}


function onCancel()
{
    // First, ensure that the user wants to cancel.
    var wantToCancel = dialog_yesNo("Are you sure you want to cancel "
                                    + "installing PHP Debugger support?",
                                    "No");    // default answer

    // Second, go to the "Warning" panel.
    if (wantToCancel == "Yes") {
        wd_info.ok = false;
        window.close();
    }
}


function onFinish() {
    window.close();
}


